-- $Id: FilterInsideTests.hs,v 1.1 2013/03/17 03:03:50 leavens Exp $
module FilterInsideTests where
import FilterInside
import Testing
main = do startTesting "FilterInsideTests $Revision: 1.1 $" 
          errs <- composeTests testsInteger testsChar 0
          doneTesting errs
testsInteger :: [TestCase [[Integer]]]
testsInteger = [eqTest (filterInside (>2) []) "==" []
        ,eqTest (filterInside (>5) [[]]) "==" [[]]
        ,eqTest (filterInside (>5) [[1,2,3,4,5,6,7],[0,9,11]]) 
         "==" [[6,7],[9,11]]
        ,eqTest (filterInside (\x -> x < 4 || x > 7) 
              [[3,9,86,99,6,7,8,7,1],[0,4,9,11],[],[52,3,8,-4]]) 
         "==" [[3,9,86,99,8,1],[0,9,11],[],[52,3,8,-4]]
        ]
testsChar :: [TestCase [[Char]]]
testsChar = [eqTest (filterInside (>'c') []) "==" []
        ,eqTest (filterInside (>'a') [[]]) "==" [[]]
        ,eqTest (filterInside (>'a') [['a','l','p','h','a'],"beta"]) 
         "==" ["lph","bet"]
        ,eqTest (filterInside (\c -> c /= 'a' && c /= 'e' && c /= 'i')
              ["blanched cherry","pie","plain pannini","pure","pita"])
         "==" ["blnchd chrry","p","pln pnnn","pur","pt"]
        ]
