-- $Id: FoldBTreeTests.hs,v 1.1 2013/03/18 19:56:33 leavens Exp leavens $
module FoldBTreeTests where
import BTree
import FoldBTree
import Testing
main = do startTesting "FoldBTreeTests $Revision: 1.1 $" 
          errs <- composeTests testsInteger testsBool 0
          doneTesting errs
-- The following definitions are just for use in testing, not for you to write!
total :: Num a => BTree a -> a
total = foldBTree id (\lr x rr -> lr + x + rr)
inorder :: BTree a -> [a]
inorder bt = foldBTree (\x -> [x]) (\lr x rr -> lr ++ (x : rr)) bt
preorder :: BTree a -> [a]
preorder = foldBTree (\x -> [x]) (\lr x rr -> x : (lr ++ rr))
tmap :: (a -> b) -> BTree a -> BTree b
tmap f = foldBTree (\x -> Value (f x)) (\lr x rr -> (Node lr (f x) rr))
-- End of example definitions for help in testing, start of test cases
testsInteger :: [TestCase Integer]
testsInteger = 
    [eqTest (total (Value 7)) "==" 7
    ,eqTest (total (Node (Value 3) 4 (Value 5))) "==" 12
    ,eqTest (total (Node (Node (Value 1) 2 (Value 3)) 4 (Value 5))) "==" 15
    ,eqTest (total (Node (Node (Value 1) 2 (Value 3)) 4 
                   (Node (Value 5) 100 (Value 200))))
            "==" 315 ]
testsBool :: [TestCase Bool]
testsBool = 
    [assertTrue ((inorder (Value 7)) == [7])
    ,assertTrue ((inorder (Node (Value 3) 4 (Value 5))) == [3,4,5])
    ,assertTrue ((inorder (Node (Node (Value 1) 2 (Value 3)) 4 (Value 5))) 
                 == [1,2,3,4,5])
    ,assertTrue ((inorder (Node (Node (Value 'h') 'e' (Value 'l')) 'l'
                   (Node (Value 'o') '!' (Value '!'))))
                 == "hello!!")
    ,assertTrue ((preorder (Value 7)) == [7])
    ,assertTrue ((preorder (Node (Value 3) 4 (Value 5))) == [4,3,5])
    ,assertTrue ((preorder (Node (Node (Value 1) 2 (Value 3)) 4 (Value 5))) 
                 == [4,2,1,3,5])
    ,assertTrue ((preorder (Node (Node (Value 'h') 'e' (Value 'l')) 'l'
                   (Node (Value 'o') '!' (Value '!'))))
                 == "lehl!o!")
    ,assertTrue ((tmap (+1) (Value 7)) == (Value 8))
    ,assertTrue ((tmap (*2) (Node (Value 3) 4 (Value 5))) 
                 == (Node (Value 6) 8 (Value 10)))
    ,assertTrue ((tmap (==5) (Node (Node (Value 1) 2 (Value 3)) 4 (Value 5)))
                 == (Node (Node (Value False) False (Value False)) False (Value True)))
    ,assertTrue ((tmap (\c -> c:[]) 
                  (Node (Node (Value 'h') 'e' (Value 'l')) 'l'
                   (Node (Value 'o') '!' (Value '!'))))
                 == (Node (Node (Value "h") "e" (Value "l")) "l"
                            (Node (Value "o") "!" (Value "!"))))    ]
